apiVersion: {{ sts_apivers }}
kind: StatefulSet
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ prosody_name }}
  name: {{ prosody_name }}
  namespace: {{ namespace }}
spec:
  podManagementPolicy: OrderedReady
  replicas: {{ prosody_replicas }}
  selector:
    matchLabels:
      name: {{ prosody_name }}
  serviceName: {{ prosody_name }}
  template:
    metadata:
      labels:
        name: {{ prosody_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ prosody_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ prosody_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: AUTH_TYPE
          value: "{{ 'ldap' if (do_ldap) else 'internal' }}"
        - name: ENABLE_AUTH
          value: "{{ 1 if (do_ldap) else 0 }}"
        - name: ENABLE_GUESTS
          value: "{{ 1 if (jitsi_enable_guests) else 0 }}"
        - name: ENABLE_LOBBY
          value: "true"
{% if do_ldap %}
        - name: LDAP_URL
          value: "{{ ldaps_address }}"
        - name: LDAP_BASE
          value: "{{ ldap_root_dn }}"
        - name: LDAP_BINDDN
          value: "cn=jitsi,ou=services,{{ ldap_root_dn }}"
        - name: LDAP_BINDPW
          valueFrom:
            secretKeyRef:
              key: jitsi-password
              name: {{ ldap_secret_name }}
        - name: LDAP_FILTER
{% if do_fusion %}
          value: "(&(objectClass=gosaAccount)(!(pwdAccountLockedTime=*)))"
{% else %}
          value: "(&(objectClass={{ jitsi_ldap_user_objectclass }})(!(pwdAccountLockedTime=*)))"
{% endif %}
        - name: LDAP_AUTH_METHOD
          value: bind
        - name: LDAP_USE_TLS
          value: "true"
        - name: LDAP_TLS_CACERT_FILE
          value: /certs/ca.crt
        - name: LDAP_TLS_CACERT_DIR
          value: ""
        - name: LDAP_START_TLS
          value: "false"
{% else %}
{% endif %}
        - name: JICOFO_AUTH_PASSWORD
          valueFrom:
            secretKeyRef:
              key: admin-password
              name: {{ jicofo_name }}
        - name: JICOFO_AUTH_USER
          valueFrom:
            secretKeyRef:
              key: admin-user
              name: {{ jicofo_name }}
        - name: JICOFO_COMPONENT_SECRET
          valueFrom:
            secretKeyRef:
              key: component-secret
              name: {{ jitsi_name }}
        - name: JVB_AUTH_PASSWORD
          valueFrom:
            secretKeyRef:
              key: admin-password
              name: {{ jvb_name }}
        - name: JVB_AUTH_USER
          valueFrom:
            secretKeyRef:
              key: admin-user
              name: {{ jvb_name }}
        - name: JVB_TCP_HARVESTER_DISABLED
          value: "true"
        - name: TZ
          value: {{ timezone }}
        - name: PUBLIC_URL
          value: https://{{ jitsi_fqdn }}
        - name: XMPP_AUTH_DOMAIN
          value: auth.meet.{{ namespace }}.svc.{{ cluster_domain }}
        - name: XMPP_DOMAIN
          value: meet.{{ namespace }}.svc.{{ cluster_domain }}
        - name: XMPP_GUEST_DOMAIN
          value: guest.meet.{{ namespace }}.svc.{{ cluster_domain }}
        - name: XMPP_INTERNAL_MUC_DOMAIN
          value: internal-muc.meet.{{ namespace }}.svc.{{ cluster_domain }}
        - name: XMPP_MUC_DOMAIN
          value: muc.meet.{{ namespace }}.svc.{{ cluster_domain }}
        - name: XMPP_RECORDER_DOMAIN
          value: recorder.meet.{{ namespace }}.svc.{{ cluster_domain }}
        image: {{ (opsimages | json_query("[?name=='prosody'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          tcpSocket:
            port: 5222
        name: prosody
        ports:
        - containerPort: 5222
          name: xmpp-c2s
        - containerPort: 5269
          name: xmpp-s2s
        - containerPort: 5380
          name: bosh-insecure
        - containerPort: 5281
          name: bosh-secure
        - containerPort: 5347
          name: xmpp
        resources:
          limits:
            cpu: "{{ prosody_cpu_limit }}"
            memory: "{{ prosody_memory_limit }}"
          requests:
            cpu: "{{ prosody_cpu_request }}"
            memory: "{{ prosody_memory_request }}"
        securityContext:
          privileged: true
        volumeMounts:
{% if do_ldap and k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /config/data
          name: data
          subPath: config
{% if do_ldap %}
        - mountPath: /etc/ldap
          name: ldapconf
{% endif %}
        - mountPath: /prosody-plugins-custom
          name: data
          subPath: plugins
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
      serviceAccountName: {{ jitsi_name }}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ prosody_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
{% if do_ldap %}
      volumes:
      - configMap:
          name: {{ ldap_name | default('ldap') }}-config
        name: ldapconf
{% if k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% endif %}
  updateStrategy:
    type: RollingUpdate
  volumeClaimTemplates:
  - metadata:
      name: data
    spec:
      accessModes: [ ReadWriteOnce ]
      resources:
        requests:
          storage: "{{ prosody_data_capacity }}"
{% if rwo_storage is defined %}
      storageClassName: {{ rwo_storage }}
{% endif %}
